<?php

namespace App\Entity;

use App\Repository\NotConservedRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: NotConservedRepository::class)]
#[ORM\Table(name: 'non_conserv')]
class NotConserved implements \JsonSerializable
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column(length: 400, name: 'denominazione')]
    private ?string $denomination = null;

    private ?float $lat = null;

    private ?float $lng = null;

    /**
     * @var Bibliography[] $bibliographies
     */
    private ?array $bibliographies = null;

    /**
     * @var Document[] $documents
     */
    private ?array $documents = null;

    #[ORM\Column(length: 255, nullable: true, name: 'periodo')]
    private ?string $period = null;

    #[ORM\Column(length: 255, nullable: true, name: 'localita_generica')]
    private ?string $genericLocation = null;

    #[ORM\Column(type: Types::TEXT, nullable: true, name: 'descrizione_breve')]
    private ?string $shortDescription = null;

    #[ORM\Column(name: 'autore_scheda', length: 100, nullable: true)]
    private ?string $author = null;

    #[ORM\Column(name: 'comune', length: 10, nullable: false)]
    private ?string $municipality = null;

    #[ORM\Column(name: 'etichetta', length: 100, nullable: false)]
    private ?string $label = null;

    /**
     * @var Image[] $images
     */
    private ?array $images = null;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function setId(string $id): static
    {
        $this->id = $id;

        return $this;
    }

    public function getdenomination(): ?string
    {
        return $this->denomination;
    }

    public function setdenomination(string $denomination): static
    {
        $this->denomination = $denomination;

        return $this;
    }

    public function getLat(): ?float
    {
        return $this->lat;
    }

    public function setLat(?float $lat): static
    {
        $this->lat = $lat;

        return $this;
    }

    public function getLng(): ?float
    {
        return $this->lng;
    }

    public function setLng(?float $lng): static
    {
        $this->lng = $lng;

        return $this;
    }

    public function getBibliographies(): ?array
    {
        return $this->bibliographies;
    }

    public function setBibliographies(array $bibliographies): static
    {
        $this->bibliographies = $bibliographies;

        return $this;
    }

    public function getDocuments(): ?array
    {
        return $this->documents;
    }

    public function setDocuments(array $documents): static
    {
        $this->documents = $documents;

        return $this;
    }

    public function getPeriod(): ?string
    {
        return $this->period;
    }

    public function setPeriod(?string $period): static
    {
        $this->period = $period;

        return $this;
    }

    public function getGenericLocation(): ?string
    {
        return $this->genericLocation;
    }

    public function setGenericLocation(?string $genericLocation): static
    {
        $this->genericLocation = $genericLocation;

        return $this;
    }

    public function getShortDescription(): ?string
    {
        return $this->shortDescription;
    }

    public function setShortDescription(?string $shortDescription): static
    {
        $this->shortDescription = $shortDescription;

        return $this;
    }

    public function getAuthor(): ?string
    {
        return $this->author;
    }

    public function setAuthor(?string $author): static
    {
        $this->author = $author;

        return $this;
    }

    public function getLabel(): ?string
    {
        return $this->label;
    }

    public function setLabel(?string $label): static
    {
        $this->label = $label;

        return $this;
    }

    public function getMunicipality(): ?string
    {
        return $this->municipality;
    }

    public function setMunicipality(?string $municipality): static
    {
        $this->municipality = $municipality;

        return $this;
    }

    /**
     * @return Image[]
     */
    public function getImages(): array
    {
        return $this->images;
    }

    /**
     * @param Image[] $images
     */
    public function setImages(array $images): static
    {
        $this->images = $images;

        return $this;
    }

    public function jsonSerialize(): array
    {
        return [
            'id' => $this->id,
            'coordinates' => [$this->lat, $this->lng],
            'denomination' => $this->denomination,
            'genericLocation' => $this->genericLocation,
            'period' => $this->period,
            'shortDescription' => $this->shortDescription,
            'author' => $this->author,
            'municipality' => $this->municipality,
            'label' => $this->label,
            'bibliography' => $this->bibliographies,
            'documents' => $this->documents,
            'images' => $this->images,
        ];
    }
}
