<?php

namespace App\Entity;

use App\Repository\UnderwaterRepository;
use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping as ORM;
use JsonSerializable;

#[ORM\Entity(repositoryClass: UnderwaterRepository::class)]
#[ORM\Table(name: 'giacimento')]
class Underwater implements JsonSerializable
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column(length: 255, name: 'denominazione')]
    private ?string $denomination = null;

    #[ORM\Column(length: 255, nullable: true, name: 'loc_generica')]
    private ?string $genericPlace = null;

    #[ORM\Column(length: 100, nullable: true, name: 'periodo')]
    private ?string $period = null;

    #[ORM\Column(type: Types::TEXT, nullable: true, name: 'descrizione_breve')]
    private ?string $shortDescription = null;

    #[ORM\Column(length: 100, nullable: true, name: 'conservazione')]
    private ?string $conservationState = null;

    #[ORM\Column(length: 80, nullable: true, name: 'autore_scheda')]
    private ?string $author = null;
    
    #[ORM\Column(length: 80, nullable: false, name: 'etichetta')]
    private ?string $label = null;

    private ?float $lat = null;

    private ?float $lng = null;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function setId(string $id): static
    {
        $this->id = $id;

        return $this;
    }

    public function getDenomination(): ?string
    {
        return $this->denomination;
    }

    public function setDenomination(string $denomination): static
    {
        $this->denomination = $denomination;

        return $this;
    }

    public function getGenericPlace(): ?string
    {
        return $this->genericPlace;
    }

    public function setGenericPlace(?string $genericPlace): static
    {
        $this->genericPlace = $genericPlace;

        return $this;
    }

    public function getPeriod(): ?string
    {
        return $this->period;
    }

    public function setPeriod(?string $period): static
    {
        $this->period = $period;

        return $this;
    }

    public function getShortDescription(): ?string
    {
        return $this->shortDescription;
    }

    public function setShortDescription(?string $shortDescription): static
    {
        $this->shortDescription = $shortDescription;

        return $this;
    }

    public function getConservationState(): ?string
    {
        return $this->conservationState;
    }

    public function setConservationState(?string $conservationState): static
    {
        $this->conservationState = $conservationState;

        return $this;
    }

    public function getAuthor(): ?string
    {
        return $this->author;
    }

    public function setAuthor(?string $author): static
    {
        $this->author = $author;

        return $this;
    }

    public function getLabel(): ?string
    {
        return $this->label;
    }

    public function setLabel(?string $label): static
    {
        $this->label = $label;

        return $this;
    }

    public function getLat(): ?float
    {
        return $this->lat;
    }

    public function setLat(?float $latitude): static
    {
        $this->lat = $latitude;

        return $this;
    }

    public function getLng(): ?float
    {
        return $this->lng;
    }

    public function setLng(?float $longitude): static
    {
        $this->lng = $longitude;

        return $this;
    }

    public function jsonSerialize(): array
    {
        return [
            'id' => $this->id,
            'genericPlace' => $this->genericPlace,
            'coordinates' => [$this->lat, $this->lng],
            'denomination' => $this->denomination,
            'period' => $this->period,
            'conservationState' => $this->conservationState,
            'shortDescription' => $this->shortDescription,
            'author' => $this->author,
            'label' => $this->label,
        ];
    }
}
